<?php

#
# Note*: You may also need to translate manually other files,
# like footer.php, or other pages you may have had added
# Also don`t forget to translate site settings, like description,
# name and slogan from admin.php.
#

$lang = array();

// Main Page translations


$lang['main_welcome_to']           = 'Hey, and welcome';
$lang['main_site']                 = 'Site';
$lang['main_site_placeholder']     = 'http://gooogle.com';
$lang['main_keywords']             = 'Keywords';
$lang['main_keywords_placeholder'] = 'cheap liquor,free apps,funny movies';
$lang['main_seo_profile']     	   = 'SEO profile';
$lang['main_seo_profile_not'] 	   = 'none available';   
$lang['main_about_profile']   	   = 'Details';
$lang['main_sites_analysed']  	   = 'Analysed sites';
$lang['main_like_us']         	   = 'Like us on facebook';   

// SEO test finished translations

$lang['analised_loading'] 				 = 'Generating SEO raport for';
$lang['analised_host_up'] 				 = 'Host up';
$lang['analised_host_down']              = 'Host down';
$lang['analised_host_down_tips']         = 'Check if the domain is correct or/and the host is up!';
$lang['analised_profile']                = 'SEO profile loaded';
$lang['analised_profile_err']            = 'Please select a SEO profile before you try to run the test';
$lang['analised_keywords_used']          = 'Used keywords';
$lang['analised_view']                   = 'View';
$lang['analised_dl_download']            = 'Download';
$lang['analised_the_pdf']                = 'this SEO raport as PDF';
$lang['analised_score']                  = 'Score';
$lang['analised_generated']              = 'Generated in';
$lang['analised_bad']                    = 'Bad';
$lang['analised_decent']                 = 'Good';
$lang['analised_perfect']                = 'Perfect';
$lang['analised_host_info']              = 'Host information';
$lang['analised_host_adress']            = 'IP Adress';
$lang['analised_host_blacklist_status']  = 'Status Blacklist';
$lang['analised_host_country']           = 'Country';
$lang['analised_host_region']            = 'Region';
$lang['analised_host_provider']          = 'Provider';
$lang['analised_domain_info']            = 'Domain information';
$lang['analised_domain_pagerank']        = 'Pagerank';
$lang['analised_domain_alexarank']       = 'Rank Alexa';
$lang['analised_domain_alexapopularity'] = 'Alexa popularity';
$lang['analised_domain_whois']           = 'Whois';
$lang['analised_domain_view_whois']      = 'See WhoIs information';
$lang['analised_seo_raport']             = 'SEO Raport';

// SEO results translations

$lang['category_crawling'] = 'Crawling';
$lang['crawling_http']     = 'HTTP code check';
$lang['crawling_robots']   = 'Robots.txt check';
$lang['crawling_sitemap']  = 'Sitemap check';

$lang['category_head'] = 'Head elements';

$lang['head_title_check']       = 'Title checks';
$lang['head_title_title']       = 'Title';
$lang['head_title_length']      = 'Length';
$lang['head_title_stop_words']  = 'Stop words';
$lang['head_title_kwintitle']   = 'Keywords in title';
$lang['head_title_relevance']   = 'Keywords relevance';
$lang['head_kw_keywords_check'] = 'Meta keywords checks';
$lang['head_kw_keywords']       = 'Keywords';
$lang['head_kw_count']          = 'Number of keywords';
$lang['head_kw_rel']            = 'Relevane with site';
$lang['head_desc_check']        = 'Meta description checks';
$lang['head_desc_desc']         = 'Description';
$lang['head_desc_length']       = 'Length';
$lang['head_desc_kwindesc']     = 'Keywords in description';
$lang['head_desc_relevance']    = 'Relevance with keywords';

$lang['category_content']  = 'Content';
$lang['content_language']  = 'Language';
$lang['content_charcount'] = 'Number of characters';
$lang['content_wordcount'] = 'Number of words';
$lang['content_kwin']      = 'Keywords present';
$lang['content_rel']       = 'Relevance with the content';
$lang['content_kwini']     = 'Words in italic';
$lang['content_kwinb']     = 'Words in bold';
$lang['content_headings']  = 'Headings';
$lang['content_iframes']   = 'Iframes';

$lang['category_url']   = 'URL structure';
$lang['url_domain']     = 'Domain'; 
$lang['url_kwin']       = 'Keywords in domain';
$lang['url_length']     = 'Length';
$lang['url_subdomains'] = 'Subdomains';


$lang['category_links'] = 'Links';
$lang['links_i']        = 'Internal links';
$lang['links_e']        = 'External links';

$lang['category_ux']   = 'User experience';
$lang['ux_pagespeed']  = 'Page speed';
$lang['ux_responsive'] = 'Responsive design';
$lang['ux_grammar']    = 'Grammar mistakes';
$lang['ux_contact']    = 'Contact page';

// Other translations

$lang['label_tips'] = 'Tips and tricks';

$lang['err_notloggedin'] = 'Sorry, but you can not access this page. You need to log in first.';
$lang['err_notprovided'] = 'Unspecified';

$lang['general_ok']            = 'Ok';
$lang['general_nok']           = 'Not Ok';
$lang['general_bad']           = 'Bad';
$lang['general_notenough']     = 'Bad, not enough';
$lang['general_good']          = 'Good';
$lang['general_perfect']       = 'Perfect';
$lang['general_toomuch']       = 'Bad, too much';
$lang['general_notcomputable'] = 'Could not compute';

$lang['general_lang_unavailable'] = 'Service is unavailable';
$lang['general_lang_notsup']      = 'Unsuported language';

$lang['general_resp']   = 'Responsive';
$lang['genral_notresp'] = 'Not responsive';

$lang['general_present']    = 'Present';
$lang['general_notpresent'] = 'Not present';

